/***********************/
/* (c) 2007 dci@cpp.in */
/***********************/

#ifndef _IS_CLIST_HPP_
#define _IS_CLIST_HPP_

#include "is-buffer.hpp"

/* contactlist group */
struct is_cl_group
{
	unsigned short gid;
	char * name;
};

/* contactlist item */
struct is_cl_item
{
	unsigned short gid;
	unsigned short iid;
	bool awaiting_auth;
	unsigned short status;
	char * name;
	char * nick;
};

/* class template */
class is_clist
{
private:
	size_t        gnum;
	is_cl_group * groups;
	size_t        inum;
	is_cl_item *  items;
	
public:
	void addg  ( unsigned short gid, char * name );
	void addi  ( unsigned short gid, unsigned short iid, bool awaiting_auth, unsigned short status, char * name, char * nick );
	void clear ( );
	void dump  ( is_buffer * out );
	
	is_clist   ( );
	~is_clist  ( );
};

#endif
