/***********************/
/* (c) 2007 dci@cpp.in */
/***********************/

#ifndef _IS_COMMON_HPP_
#define _IS_COMMON_HPP_

/* system includes */
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <dirent.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>

/* useful stuff */
#define min(a,b) (((a)<(b))?(a):(b))


/* prototypes */
size_t utf16len ( void * str );
char * utf16dup ( void * str );

void * xmalloc  ( size_t size );
void * xrealloc ( void * ptr, size_t size );
void   xfree    ( void * ptr );

char * utf16_to_ascii ( char * utf16, int bytes );
char * utf8_to_utf16 ( char * utf8, int bytes );
char * cp1251_to_utf16 ( char * cp1251, int bytes );
#endif
