/***********************/
/* (c) 2007 dci@cpp.in */
/***********************/

#ifndef _IS_SERVER_HPP_
#define _IS_SERVER_HPP_

/* IS includes */
#include "is-common.hpp"
#include "is-buffer.hpp"
#include "is-proc.hpp"

/* network-related includes */
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

/* kqueue */
#include <sys/event.h>

/* struct scut */
typedef struct kevent kevent_t;

/* protos */
void ke_change ( int ident, int filter, int flags, int data, void * is_block );
void ke_loop ( int listen_sock );
void server ( char * iface, char * root, uid_t user, gid_t group );

#endif
